/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//(C) PicoPeta Simputers Pvt. Ltd. (2003)
// Image Library

// Programmer: Santhosh N

#include "pimg_pgm.h"

int _save_pgm_image(char *filename, Display *disp, struct Image **img)
{
	int depth, x, y;
	struct Image *simg = *img;
	unsigned char r, g, b, ch;
	unsigned short t;
	unsigned long p;
	FILE *fp;

	if(simg==NULL)
		return EBADIMG;

	fp = fopen(filename, "w");
	if(fp==NULL)
		return ENOFILE;
			
	fprintf(fp, "P5\n%d %d\n255\n", simg->width, simg->height);

	depth = DefaultDepth(disp, DefaultScreen(disp));

	for(y=0; y<simg->height; y++) {
		switch(depth) {
			case 4:
				for(x=0; x<(simg->width)/2; x++) {
					t = *(simg->img->data + y*simg->img->bytes_per_line + x);
					ch = (t&0x000f)<<4;
					fprintf(fp, "%c", ch);
					ch = t&0x00f0;
					fprintf(fp, "%c", ch);
				}
				if(simg->width&0x01) {
					t = *(simg->img->data + y*simg->img->bytes_per_line + x);
					ch = (t&0x000f)<<4;
					fprintf(fp, "%c", ch);
				}
				break;
			case 12:
				for(x=0; x<simg->width; x++) {
					memcpy(&t, simg->img->data + y*simg->width*2 + x*2,2);
					r = (t>>8)<<4; 
					g = t&0x00f0; 
					b = (t&0x000f)<<4;

					p = r*11 + g*16 + b*5;
					ch = (p>>5)&0xff;
					fprintf(fp, "%c", ch);
				}
				break;
			case 16:
				if(_rmask==0x00f800 && _gmask==0x0007e0 && _bmask==0x00001f) {
					for(x=0; x<simg->width; x++) {
						memcpy(&t, simg->img->data + y*simg->width*2 + x*2,2);

						r = (t>>11)<<3; 
						g = ((t&0x07e0)>>5)<<2; 
						b = (t&0x001f)<<3;

						p = r*11 + g*16 + b*5;
						ch = (p>>5)&0xff;
						fprintf(fp, "%c", ch);
					}
				} else {
					for(x=0; x<simg->width; x++) {
						memcpy(&t, simg->img->data + y*simg->width*2 + x*2,2);
						
						r = (t>>10)<<2;
						g = ((t&0x07e0)>>5)<<3;
						b = (t&0x001f)<<3;

						p = r*11 + g*16 + b*5;
						ch = (p>>5)&0xff;
						fprintf(fp, "%c", ch);
					}
				}

				break;
		}
	}

	fclose(fp);

	return 0;
}
