/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
//(C) PicoPeta Simputers Pvt. Ltd. (2003)
#include "plib.h"
#include<fcntl.h>
#include<unistd.h>
#include <netinet/in.h>

int pimg_scrshot(Display *disp, struct Image **simg)
{
#ifdef __arm__
	int depth, bytes=0, bytes_read=0, fd;
	struct Image *img;
	unsigned char *ibuff;

	depth = DefaultDepth(disp, DefaultScreen(disp));

	if(depth!=4 && depth!=12 && depth!=16)
		return EBADDEP;

	// Create the Image and add to the list
	img = (struct Image*)malloc(sizeof(struct Image));
	img->info = img->delay = img->x = img->y = 0;
	img->width = 240;
	img->height = 320;
	img->next = NULL;
	img->img = img->mimg = NULL;

	if(depth==4)
		bytes = 38400;
	else if(depth==12)
		bytes = 153600;
	else if(depth==16)
		bytes = 153600;
	
	ibuff = (unsigned char*)malloc(img->width*img->height*2);
	memset(ibuff, 0, img->width*img->height*2);
	
	fd = open("/dev/fb0", O_RDONLY);
	if(fd>0) {
		while(bytes_read < bytes)
			bytes_read += read(fd, ibuff+bytes_read, bytes);
		close(fd);
	} else
		return ENOFILE;

	if(depth==4) {			// MONO
		unsigned char data[320][240];
		int i, j, t;

		for(i=0;i<240;i++) {
			for(j=0;j<160;j++) {
				data[2*j][240-i-1] = (ibuff[i*160+j] & 0xf );
				data[2*j+1][240-i-1] = (ibuff[i*160+j] >> 4);
			}
		}

		for(i=0;i<320;i++)
			for(j=0, t=0; j<240; j+=2, t++) {
				ibuff[240*i+t] = (data[i][j])|(data[i][j+1]<<4);
			}

		img->img = XCreateImage(disp, CopyFromParent, depth, ZPixmap, 0,\
						ibuff, img->width, img->height, 8, img->width);
	}
	if(depth==12) {		// STN
		int i;
		unsigned short c1, c2;

		for(i=0; i<bytes/2; i+=2) {
			memcpy((unsigned char*)&c1, ibuff+i, 2);
			memcpy((unsigned char*)&c2, ibuff+(bytes-1-i-2), 2);
			c1 = htons(c1);
			c2 = htons(c2);
			memcpy(ibuff+i, (unsigned char*)&c2, 2);
			memcpy(ibuff+(bytes-1-i-2), (unsigned char*)&c1, 2);
		}
		
		img->img = XCreateImage(disp, CopyFromParent, depth, ZPixmap, 0,\
						ibuff, img->width, img->height, 16, img->width*2);
	}
	if(depth==16) {		// TFT
		img->img = XCreateImage(disp, CopyFromParent, depth, ZPixmap, 0,\
						ibuff, img->width, img->height, 16, img->width*2);
	}

	_pimg_imglst_add(simg, img);

	return 0;
#else
	return ENOSUPP;
#endif
}
